package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WFAssistWork;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WFAssistWorkSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WFAssistWork> selectCond;
	private JSONObject customsearchval;
	public WFAssistWorkSearchFilter(){
		this.page =new Page<WFAssistWork>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WFAssistWork>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_wfassistworkname_like;

	public void setN_wfassistworkname_like(String n_wfassistworkname_like) {
        this.n_wfassistworkname_like = n_wfassistworkname_like;
        if(!StringUtils.isEmpty(this.n_wfassistworkname_like)){
            this.selectCond.like("wfassistworkname", n_wfassistworkname_like);
        }
    }
	private String n_wfinstanceid_eq;

	public void setN_wfinstanceid_eq(String n_wfinstanceid_eq) {
        this.n_wfinstanceid_eq = n_wfinstanceid_eq;
        if(!StringUtils.isEmpty(this.n_wfinstanceid_eq)){
            this.selectCond.eq("wfinstanceid", n_wfinstanceid_eq);
        }
    }
	private String n_wfinstancename_eq;

	public void setN_wfinstancename_eq(String n_wfinstancename_eq) {
        this.n_wfinstancename_eq = n_wfinstancename_eq;
        if(!StringUtils.isEmpty(this.n_wfinstancename_eq)){
            this.selectCond.eq("wfinstancename", n_wfinstancename_eq);
        }
    }
	private String n_wfinstancename_like;

	public void setN_wfinstancename_like(String n_wfinstancename_like) {
        this.n_wfinstancename_like = n_wfinstancename_like;
        if(!StringUtils.isEmpty(this.n_wfinstancename_like)){
            this.selectCond.like("wfinstancename", n_wfinstancename_like);
        }
    }
	private String n_wfstepactorid_eq;

	public void setN_wfstepactorid_eq(String n_wfstepactorid_eq) {
        this.n_wfstepactorid_eq = n_wfstepactorid_eq;
        if(!StringUtils.isEmpty(this.n_wfstepactorid_eq)){
            this.selectCond.eq("wfstepactorid", n_wfstepactorid_eq);
        }
    }
	private String n_wfstepactorname_eq;

	public void setN_wfstepactorname_eq(String n_wfstepactorname_eq) {
        this.n_wfstepactorname_eq = n_wfstepactorname_eq;
        if(!StringUtils.isEmpty(this.n_wfstepactorname_eq)){
            this.selectCond.eq("wfstepactorname", n_wfstepactorname_eq);
        }
    }
	private String n_wfstepactorname_like;

	public void setN_wfstepactorname_like(String n_wfstepactorname_like) {
        this.n_wfstepactorname_like = n_wfstepactorname_like;
        if(!StringUtils.isEmpty(this.n_wfstepactorname_like)){
            this.selectCond.like("wfstepactorname", n_wfstepactorname_like);
        }
    }
	private String n_wfworkflowid_eq;

	public void setN_wfworkflowid_eq(String n_wfworkflowid_eq) {
        this.n_wfworkflowid_eq = n_wfworkflowid_eq;
        if(!StringUtils.isEmpty(this.n_wfworkflowid_eq)){
            this.selectCond.eq("wfworkflowid", n_wfworkflowid_eq);
        }
    }
	private String n_wfworkflowname_eq;

	public void setN_wfworkflowname_eq(String n_wfworkflowname_eq) {
        this.n_wfworkflowname_eq = n_wfworkflowname_eq;
        if(!StringUtils.isEmpty(this.n_wfworkflowname_eq)){
            this.selectCond.eq("wfworkflowname", n_wfworkflowname_eq);
        }
    }
	private String n_wfworkflowname_like;

	public void setN_wfworkflowname_like(String n_wfworkflowname_like) {
        this.n_wfworkflowname_like = n_wfworkflowname_like;
        if(!StringUtils.isEmpty(this.n_wfworkflowname_like)){
            this.selectCond.like("wfworkflowname", n_wfworkflowname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFASSISTWORK_WFINSTANCE_WFINSTANCEID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfinstanceid_eq("NA");
			}
			else{
				this.setN_wfinstanceid_eq(strParentkey);
			}
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFASSISTWORK_WFSTEPACTOR_WFSTEPACTORID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfstepactorid_eq("NA");
			}
			else{
				this.setN_wfstepactorid_eq(strParentkey);
			}
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFASSISTWORK_WFWORKFLOW_WFWORKFLOWID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfworkflowid_eq("NA");
			}
			else{
				this.setN_wfworkflowid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wfassistworkname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}